VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Solid Edge Dateieigenschaften"
   ClientHeight    =   4095
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   4635
   LinkTopic       =   "Form1"
   ScaleHeight     =   4095
   ScaleWidth      =   4635
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Frame frmePropWrite 
      Height          =   1815
      Left            =   120
      TabIndex        =   3
      Top             =   1440
      Width           =   4335
      Begin VB.TextBox tbPropValue 
         Height          =   375
         Left            =   2280
         TabIndex        =   6
         Text            =   "Test"
         Top             =   1200
         Width           =   1935
      End
      Begin VB.TextBox tbPropName 
         Height          =   375
         Left            =   120
         TabIndex        =   5
         Text            =   "Test"
         Top             =   1200
         Width           =   1935
      End
      Begin VB.CommandButton CmdWriteProperties 
         Caption         =   "Custom-Properties erzeugen / ndern"
         Height          =   495
         Left            =   120
         TabIndex        =   4
         Top             =   360
         Width           =   4095
      End
      Begin VB.Label lbPropValue 
         Caption         =   "Property-Wert"
         Height          =   255
         Left            =   2280
         TabIndex        =   8
         Top             =   960
         Width           =   1335
      End
      Begin VB.Label lbPropName 
         Caption         =   "Property-Name"
         Height          =   255
         Left            =   120
         TabIndex        =   7
         Top             =   960
         Width           =   1215
      End
   End
   Begin VB.CommandButton CmdProperties2Array 
      Caption         =   "Properties in Array schreiben"
      Height          =   495
      Left            =   240
      TabIndex        =   2
      Top             =   720
      Width           =   4095
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   495
      Left            =   240
      TabIndex        =   0
      Top             =   3360
      Width           =   4095
   End
   Begin VB.CommandButton CmdProperties2File 
      Caption         =   "Properties in Datei schreiben"
      Height          =   495
      Left            =   240
      TabIndex        =   1
      Top             =   120
      Width           =   4095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'Beispielprogramm zum Lesen, ndern, Speichern der Solid Edge Dateieigenschften
'==============================================================================
'System: Visual Basic 6.0 (SP6) / Solid Edge V20 (SP13)


'Objekt-Hirarchie der Dateieigenschaften
'---------------------------------------
'SolidEdge.Application
'   .ActiveDocument
'       .PropertySets
'           .PropertySet
'               .Properties
'                   .Property
'---------------------------------------


'PropArray()
'---------------------------------------
'i.0: PropertySet-Name
'i.1: Property-Name
'i.2: Property-Wert
'---------------------------------------

Option Explicit

Private objApp As Object       'SolidEdge.Application
Private objDoc As Object       'ActiveDocument
Private objPropSets As Object  'PropertySets
Private objPropSet As Object   'PropertySet
Private objProps As Object     'Properties
Private objProp As Object      'Property
Private objPropNew As Object   'neues Property

Private CheckProp As Boolean   'Flag ob Property schon vorhanden
Private PropName As String     'Name des (neuen) Custom-Properties
Private PropValue As String    'Wert des (neuen) Custom-Properties
Private PropFile As String     'Dateiname der Ausgabedatei im Applikationsverzeichnis
Private PropArray() As Variant 'Datenfeld (Array) fr alle Properties
Private ArrayIndex As Integer   'Zhler zum Vergrern des Arrays
Private i As Integer           'allgemeiner Zhler


Private Sub Form_Load()

'Fehlerbehandlung ein
On Error Resume Next

'Prfen, ob SE luft
Set objApp = GetObject(, "SolidEdge.Application")
If Err Then
    MsgBox "Solid Edge ist nicht gestartet."
    Call cmdExit_Click
End If

'Prfen, ob ein Dokument geffnet ist
Set objDoc = objApp.ActiveDocument
If Err Then
    MsgBox "Kein Dokument in Solid Edge aktiv."
    Call cmdExit_Click
End If

'Fehlerbehandlung aus
On Error GoTo 0

Set objPropSets = objDoc.Properties

PropFile = "\current_props.txt"

End Sub

'Alle Properties in eine Datei schreiben
Private Sub CmdProperties2File_Click()

Open App.Path & PropFile For Output As #1

For Each objPropSet In objPropSets
    Set objProps = objPropSet
    
    For Each objProp In objProps
        Print #1, objPropSet.Name & " : " & objProp.Name & " : " & objProp.Value
    Next
Next

Close

cmdExit.SetFocus

End Sub

Private Sub CmdProperties2Array_Click()
'Alle Properties in ein Array schreiben
ArrayIndex = 0

For Each objPropSet In objPropSets
    Set objProps = objPropSet
    
    For Each objProp In objProps
    
        'Array vergrssern
        ArrayIndex = ArrayIndex + 1
        ReDim Preserve PropArray(3, ArrayIndex)
        
        PropArray(0, ArrayIndex) = objPropSet.Name
        PropArray(1, ArrayIndex) = objProp.Name
        PropArray(2, ArrayIndex) = objProp.Value
        
    Next
Next

'Zum Testen des Arrays
For i = 1 To UBound(PropArray, 2)
    Debug.Print PropArray(0, i) & " / " & PropArray(1, i) & ": " & PropArray(2, i)
Next i

cmdExit.SetFocus

End Sub

'Custom Property schreiben
Private Sub CmdWriteProperties_Click()

'Textboxen aus dem Formular auslesen
PropName = tbPropName.Text
PropValue = tbPropValue.Text

CheckProp = False

For Each objPropSet In objPropSets

    If objPropSet.Name = "Custom" Then
    Set objProps = objPropSet
    
    'Prfen, ob Property schon vorhanden ist.
    For Each objProp In objProps
        If objProp.Name = PropName Then CheckProp = True
    Next
        
    'Property setzen
    If CheckProp = True Then
        'Wert fr PropValue setzen
        objProps.Item(PropName).Value = PropValue
    Else
        'Property PropName erzeugen und Wert setzen
        Set objPropNew = objProps.Add(PropName, PropValue)
    End If
        
    End If
    
Next

'Jetzt noch sichern
objPropSets.Save

cmdExit.SetFocus

End Sub

Private Sub cmdExit_Click()

'Aufrumen
Set objApp = Nothing
Set objDoc = Nothing
Set objProp = Nothing
Set objProps = Nothing
Set objPropSet = Nothing
Set objPropSets = Nothing
Set objPropNew = Nothing

End

End Sub

